/*
 * This file is part of Nuts Framework.
 * Copyright(C) 2009-2012 Nuts Develop Team.
 *
 * Nuts Framework is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License any later version.
 * 
 * Nuts Framework is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Nuts Framework. If not, see <http://www.gnu.org/licenses/>.
 */
package nuts.core.orm.sql.engine;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import nuts.core.beans.BeanHandler;
import nuts.core.beans.BeanHandlerFactory;
import nuts.core.orm.type.TypeHandler;
import nuts.core.orm.type.TypeHandlerFactory;

/**
 * SimpleSqlStatement
 */
public class SimpleSqlParser implements SqlParser {
	/**
	 * SqlSegment
	 */
	protected static interface SqlSegment {
		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters);
	}

	//-------------------------------------------------------------------------
	// Implements 
	//-------------------------------------------------------------------------
	/**
	 * AsAliasSegment
	 */
	protected static class AsAliasSegment implements SqlSegment {
		protected String alias;

		/**
		 * Constructor
		 * @param alias alias
		 */
		public AsAliasSegment(String alias) {
			this.alias = SqlNamingUtils.javaName2ColumnLabel(alias);
		}

		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		public String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters) {
			strings.add(alias);
			return alias;
		}
	}

	/**
	 * ParameterSegment
	 */
	protected static class ParameterSegment implements SqlSegment {
		private String name;
		private String type;
		private Integer scale; 
		private String mode;
		
		/**
		 * Constructor
		 * @param parameter parameter
		 */
		public ParameterSegment(String parameter) {
			parse(parameter);
		}
		
		/**
		 * parse
		 * @param content content
		 */
		protected void parse(String content) {
			name = content;
			int i = name.indexOf(':');
			if (i > 0) {
				type = name.substring(i + 1).toUpperCase();
				name = name.substring(0, i);

				i = type.indexOf(':');
				if (i > 0) {
					mode = type.substring(i + 1);
					type = type.substring(0, i);
				}

				i = type.indexOf('.');
				if (i > 0) {
					try {
						scale = Integer.parseInt(type.substring(i + 1));
					}
					catch (NumberFormatException e) {
						throw new IllegalArgumentException("Illegal parameter: scale must be a parsable integer.", e);
					}
					type = type.substring(0, i);
				}
//				
//				Integer sqlType = JdbcTypeRegistry.getType(type);
//				if (sqlType == null) {
//					throw new IllegalArgumentException("Illegal parameter '" + name + "': unknown JDBC type [" + type + "].");
//				}
			}
		}

		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		@SuppressWarnings("unchecked")
		public String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters) {
			String translatedString = null;

			Object paramValue = null;
			if (paramObject != null) {
				BeanHandler beanHandler = BeanHandlerFactory.getInstance().getBeanHandler(paramObject.getClass());
				paramValue = beanHandler.getBeanValue(paramObject, name);
			}

			if (paramValue != null) {
				TypeHandler typeHandler = TypeHandlerFactory.getInstance().getTypeHandler(paramValue.getClass(), type);
				if (typeHandler == null) {
					if (paramValue.getClass().isArray()) {
						int len = Array.getLength(paramValue);
						if (len > 0) {
							StringBuilder sb = null;
							for (int i = 0; i < len; i++) {
								Object v = Array.get(paramValue, i);
								parameters.add(new SqlParameter(name, v, type, scale, mode));
								if (sb == null) {
									sb = new StringBuilder(len * 2);
								}
								else {
									sb.append(',');
								}
								sb.append('?');
							}
							translatedString = sb.toString(); 
							strings.add(translatedString);
							return translatedString;
						}
					}
					else if (paramValue instanceof Collection) {
						Collection c = (Collection)paramValue;
						if (!c.isEmpty()) {
							StringBuilder sb = null;
							for (Object v : c) {
								parameters.add(new SqlParameter(name, v, type, scale, mode));
								if (sb == null) {
									sb = new StringBuilder(c.size() * 2);
								}
								else {
									sb.append(',');
								}
								sb.append('?');
							}
							translatedString = sb.toString(); 
							strings.add(translatedString);
							return translatedString;
						}
					}
				}
			}

			translatedString = "?";
			parameters.add(new SqlParameter(name, paramValue, type, scale, mode));
			strings.add(translatedString);
			return translatedString;
		}
	}

	/**
	 * ReplacementExpression
	 */
	protected static class ReplacementSegment implements SqlSegment {
		private String propertyName;

		/**
		 * Constructor
		 * @param propertyName property name
		 */
		public ReplacementSegment(String propertyName) {
			this.propertyName = propertyName;
		}
		
		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		@SuppressWarnings("unchecked")
		public String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters) {
			String translatedString = null;
			
			Object repValue = null;
			if (paramObject != null) {
				BeanHandler beanHandler = BeanHandlerFactory.getInstance().getBeanHandler(paramObject.getClass());
				repValue = beanHandler.getBeanValue(paramObject, propertyName);
			}

			if (repValue != null) {
				translatedString = repValue.toString();
				strings.add(translatedString);
			}
			
			return translatedString;
		}
	}

	/**
	 * SqlCommentExpression
	 */
	protected static class SqlCommentSegment implements SqlSegment {
		private String comment;
		
		/**
		 * Constructor
		 * @param comment comment
		 */
		public SqlCommentSegment(String comment) {
			this.comment = comment;
		}

		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		public String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters) {
			strings.add(comment);
			return comment;
		}
	}

	/**
	 * SqlStringSegment
	 */
	protected static class SqlStringSegment implements SqlSegment {
		private String string;
		
		/**
		 * @param string string
		 */
		public SqlStringSegment(String string) {
			this.string = string;
		}

		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		public String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters) {
			strings.add(string);
			return string;
		}
	}

	/**
	 * SqlWordSegment
	 */
	protected static class SqlWordSegment implements SqlSegment {
		private static final int NORMAL = 0;
		private static final int COMMA = 1;
		private static final int AS = 2;
		private static final int AND = 3;
		private static final int OR = 4;
		
		private int kind;
		private String content;
		
		/**
		 * @param content content
		 */
		public SqlWordSegment(String content) {
			this.content = content;

			if (",".equals(content)) {
				kind = COMMA;
			}
			else if ("AS".equalsIgnoreCase(content)) {
				kind = AS;
			}
			else if ("AND".equalsIgnoreCase(content)) {
				kind = AND;
			}
			else if ("OR".equalsIgnoreCase(content)) {
				kind = OR;
			}
			else {
				kind = NORMAL;
			}
		}

		/**
		 * translate 
		 * @param paramObject parameter object
		 * @param strings strings
		 * @param parameters parameters
		 * @return translated string
		 */
		public String translate(Object paramObject, List<String> strings, List<SqlParameter> parameters) {
			if (kind == AND || kind == OR) {
				if (!strings.isEmpty()) {
					String prev = strings.get(strings.size() - 1);
					if ("WHERE".equalsIgnoreCase(prev) || prev.endsWith("(")) {
						return null;
					}
				}
			}
			else if (kind == COMMA) {
				if (!strings.isEmpty()) {
					String prev = strings.get(strings.size() - 1);
					if ("SET".equalsIgnoreCase(prev) || "BY".equalsIgnoreCase(prev)) {
						return null;
					}
				}
			}

			strings.add(content);
			return content;
		}
	}

	//-------------------------------------------------------------------------
	// properties
	//-------------------------------------------------------------------------
	protected List<SqlSegment> segments;
	
	/**
	 * Constructor
	 * @param sql sql statement
	 */
	public SimpleSqlParser(String sql) {
		segments = new ArrayList<SqlSegment>();
		compile(sql, segments);
	}

	/**
	 * parse sql by parameter
	 * @param parameterObject parameter
	 * @param sqlParams parameter list (output)
	 * @return jdbc sql  
	 */
	public String parse(Object parameterObject, List<SqlParameter> sqlParams) {
		List<String> strings = new ArrayList<String>();
		
		StringBuilder sb = null;
		for (SqlSegment seg : segments) {
			String sql = seg.translate(parameterObject, strings, sqlParams);
			if (sql != null && sql.length() > 0) {
				if (sb == null) {
					sb = new StringBuilder();
					sb.append(sql);
				}
				else {
					sb.append(' ');
					sb.append(sql);
				}
			}
		}

		String sql = sb == null ? null : sb.toString();
		return sql;
	}

	/**
	 * compile sql to segments
	 * 
	 * @param sql sql
	 * @param segments segments
	 */
	protected void compile(String sql, List<SqlSegment> segments) {
		int i;
		int start = 0;
		for (i = start; i < sql.length(); i++) {
			char c = sql.charAt(i);
			if (c == '/') {
				if (i + 1 < sql.length() && sql.charAt(i + 1) == '*') {
					if (i > start) {
						split(sql.substring(start, i), segments);
					}
					start = i;
					String comment = null;
					if (i + 2 < sql.length()) {
						int j = sql.indexOf("*/", i + 2);
						if (j > 0) {
							comment = sql.substring(i, j + 2);
							i = j + 1;
							start = j + 2;
						}
					}
					if (comment == null) {
						throw new IllegalArgumentException("Illegal sql statement (" + i + "): unexpected end of comment reached.");
					}
					
					segments.add(new SqlCommentSegment(comment));
				}
			}
			else if (c == '\'') {
				if (i > start) {
					split(sql.substring(start, i), segments);
				}
				start = i++;
				if (i >= sql.length()) {
					throw new IllegalArgumentException("Illegal sql statement (" + start + "): unexpected character ' reached.");
				}

				String str = null;
				for (; i < sql.length(); i++) {
					if (sql.charAt(i) == '\'') {
						if (i + 1 < sql.length() && sql.charAt(i + 1) == '\'') {
							i++;
							continue;
						}
						str = sql.substring(start, i + 1);
						start = i + 1;
						break;
					}
				}
				if (str == null) {
					throw new IllegalArgumentException("Illegal sql statement (" + start + "): unexpected end of string reached.");
				}
				segments.add(new SqlStringSegment(str));
			}
			else if (c == ':') {
				if (i > start) {
					split(sql.substring(start, i), segments);
				}

				start = i;
				for (i++; i < sql.length(); i++) {
					char c2 = sql.charAt(i);
					if (!Character.isJavaIdentifierPart(c2)	&& c2 != ':' && c2 != '.') {
						break;
					}
				}

				boolean dual = false;
				String param = sql.substring(start + 1, i);
				if (param.length() > 0 && param.charAt(0) == ':') {
					dual = true;
					param = param.substring(1);
				}
				if (param.length() < 1) {
					throw new IllegalArgumentException("Illegal sql statement (" + start + "): unexpected character : reached.");
				}

				if (dual) {
					segments.add(new ReplacementSegment(param));
				}
				else {
					segments.add(new ParameterSegment(param));
				}
				start = i--;
			}
		}

		if (i > start) {
			split(sql.substring(start, i), segments);
		}
	}

	/**
	 * isLastAsWord
	 * @param segments segments
	 * @return true if the last segment is 'AS'
	 */
	protected boolean isLastAsWord(List<SqlSegment> segments) {
		if (segments.isEmpty()) {
			return false;
		}
		
		SqlSegment seg = segments.get(segments.size() - 1);
		if (seg instanceof SqlWordSegment) {
			SqlWordSegment sws = (SqlWordSegment)seg;
			return sws.kind == SqlWordSegment.AS;
		}
		return false;
	}
	
	/**
	 * append sql
	 * @param sql sql
	 * @param segments segments
	 */
	protected void append(String sql, List<SqlSegment> segments) {
		if (isLastAsWord(segments)) {
			segments.add(new AsAliasSegment(sql));
		}
		else {
			segments.add(new SqlWordSegment(sql));
		}
	}

	/**
	 * split sql
	 * @param sql sql
	 * @param segments segments
	 */
	protected void split(String sql, List<SqlSegment> segments) {
		int start = 0;
		int i = 0;
		for (; i < sql.length(); i++) {
			int c = sql.charAt(i);
			if (Character.isWhitespace(c)) {
				if (i > start) {
					append(sql.substring(start, i), segments);
				}
				start = i + 1;
			}
			else if (c == ',') {
				if (i > start) {
					append(sql.substring(start, i), segments);
				}
				start = i + 1;
				segments.add(new SqlWordSegment(","));
			}
		}
		if (i > start) {
			append(sql.substring(start, i), segments);
		}
	}

}
